//
//  ViewController.m
//  TelesocialSocialCall
//
//  Created by Pratik Hande on 3/2/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "ViewController.h"

@implementation ViewController

@synthesize networks, conferenceIdentifier;

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    [[TSRestClient defaultClient] getAPIVersion];
    [TSRestClient defaultClient].applicationKey = @"Application_Key";
    [TSRestClient defaultClient].serviceUrl = @"https://api.telesocial.com/";
    [TSRestClient defaultClient].delegate = self;
    
    //Phone numbers need to have 1 appended at the beginning of the 10 digit number
    [[TSRestClient defaultClient] registerNetworkId:@"1" phone:@"phone1"];
    [[TSRestClient defaultClient] registerNetworkId:@"2" phone:@"phone2"];
    
    networks = [[NSMutableArray alloc] init];
    [networks addObject:@"2"];
    [[TSRestClient defaultClient] createConferenceWithNetwork:@"1" greetingId:nil recordingId:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(handleEnteredBackground)name:UIApplicationWillResignActiveNotification object:nil];
}

- (void) handleEnteredBackground
{
    NSLog(@"Handle entered background");
    [[NSNotificationCenter defaultCenter] postNotification:[NSNotification notificationWithName:@"Background" object:nil]];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
	[super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
    } else {
        return YES;
    }
}

- (void) restClient:(TSRestClient*) client didRegisterNetworkId:(NSString*) networkId 
		 withStatus:(TSStatus*) status
{
    NSString *s= [[NSString alloc] initWithFormat:@"Registered Network %@ with status: %@", networkId, status];
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:s message:networkId delegate:nil cancelButtonTitle:@"Cancel" otherButtonTitles:nil, nil];
    [alert show];
}

- (void) restClient:(TSRestClient*) client didCreateConferenceId:(NSString*) conferenceIdNo 
		 withStatus:(TSStatus*) status
{
    conferenceIdentifier = conferenceIdNo;
    [[TSRestClient defaultClient] addNetworks:networks toConference:conferenceIdentifier greetingId:nil];
    networks = [[NSMutableArray alloc] init];
    NSLog(@"%@", conferenceIdentifier);
    NSString *s= [[NSString alloc] initWithFormat:@"Created conference %@ with status: %@", conferenceIdNo, status];
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:s message:conferenceIdNo delegate:nil cancelButtonTitle:@"Cancel" otherButtonTitles:nil, nil];
    [alert show];
}

- (void) restClient:(TSRestClient*) client didAddNetworksToConference:(NSString*) confrenceIdNo
		 withStatus:(TSStatus*) status
{
    NSLog(@"In network added %@", confrenceIdNo);
    NSString *s= [[NSString alloc] initWithFormat:@"Network added %@ with status: %@", confrenceIdNo, status];
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:s message:conferenceIdentifier delegate:nil cancelButtonTitle:@"Cancel" otherButtonTitles:nil, nil];
    [alert show];
}

- (void) restClient:(TSRestClient*) client didReceiveStatus:(TSStatus*) status forNetwork:(NSString*) networkId
{
    NSString *s= [[NSString alloc] initWithFormat:@"Network  %@  registration  status: %@", networkId, status];
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:s message:networkId delegate:nil cancelButtonTitle:@"Cancel" otherButtonTitles:nil, nil];
    [alert show];
    
    if(status.code != 200 && networkId == @"1")
    {
        [[TSRestClient defaultClient] registerNetworkId:@"1" phone:@"phone1"];
    }
    else if(status.code != 200 && networkId == @"2")
    {
        [[TSRestClient defaultClient] registerNetworkId:@"2" phone:@"phone2"];
    }
    else if(status.code != 200 && networkId == @"3")
    {
        [[TSRestClient defaultClient] registerNetworkId:@"3" phone:@"phone3"];
    }
}

@end
